
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class News_postsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const news_posts = await db.news_posts.create(
            {
                id: data.id || undefined,
        
        title_om: data.title_om
        ||
        null
            ,
            
        title_am: data.title_am
        ||
        null
            ,
            
        title_en: data.title_en
        ||
        null
            ,
            
        excerpt_om: data.excerpt_om
        ||
        null
            ,
            
        excerpt_am: data.excerpt_am
        ||
        null
            ,
            
        excerpt_en: data.excerpt_en
        ||
        null
            ,
            
        content_om: data.content_om
        ||
        null
            ,
            
        content_am: data.content_am
        ||
        null
            ,
            
        content_en: data.content_en
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await news_posts.setAuthor( data.author || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.news_posts.getTableName(),
                belongsToColumn: 'featured_image',
                belongsToId: news_posts.id,
            },
            data.featured_image,
            options,
        );
        

        return news_posts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const news_postsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title_om: item.title_om
            ||
            null
            ,
            
                title_am: item.title_am
            ||
            null
            ,
            
                title_en: item.title_en
            ||
            null
            ,
            
                excerpt_om: item.excerpt_om
            ||
            null
            ,
            
                excerpt_am: item.excerpt_am
            ||
            null
            ,
            
                excerpt_en: item.excerpt_en
            ||
            null
            ,
            
                content_om: item.content_om
            ||
            null
            ,
            
                content_am: item.content_am
            ||
            null
            ,
            
                content_en: item.content_en
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const news_posts = await db.news_posts.bulkCreate(news_postsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < news_posts.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.news_posts.getTableName(),
                    belongsToColumn: 'featured_image',
                    belongsToId: news_posts[i].id,
                },
                data[i].featured_image,
                options,
            );
        }
        

        return news_posts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const news_posts = await db.news_posts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title_om !== undefined) updatePayload.title_om = data.title_om;
        
        
        if (data.title_am !== undefined) updatePayload.title_am = data.title_am;
        
        
        if (data.title_en !== undefined) updatePayload.title_en = data.title_en;
        
        
        if (data.excerpt_om !== undefined) updatePayload.excerpt_om = data.excerpt_om;
        
        
        if (data.excerpt_am !== undefined) updatePayload.excerpt_am = data.excerpt_am;
        
        
        if (data.excerpt_en !== undefined) updatePayload.excerpt_en = data.excerpt_en;
        
        
        if (data.content_om !== undefined) updatePayload.content_om = data.content_om;
        
        
        if (data.content_am !== undefined) updatePayload.content_am = data.content_am;
        
        
        if (data.content_en !== undefined) updatePayload.content_en = data.content_en;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await news_posts.update(updatePayload, {transaction});

        
        
        if (data.author !== undefined) {
            await news_posts.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.news_posts.getTableName(),
                belongsToColumn: 'featured_image',
                belongsToId: news_posts.id,
            },
            data.featured_image,
            options,
        );
        

        return news_posts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const news_posts = await db.news_posts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of news_posts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of news_posts) {
                await record.destroy({transaction});
            }
        });


        return news_posts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const news_posts = await db.news_posts.findByPk(id, options);

        await news_posts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await news_posts.destroy({
            transaction
        });

        return news_posts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const news_posts = await db.news_posts.findOne(
            { where },
            { transaction },
        );

        if (!news_posts) {
            return news_posts;
        }

        const output = news_posts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.featured_image = await news_posts.getFeatured_image({
            transaction
        });
        
        
        output.author = await news_posts.getAuthor({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.staff_members,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              full_name: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'featured_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'title_om',
                        filter.title_om,
                    ),
                };
            }
            
            if (filter.title_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'title_am',
                        filter.title_am,
                    ),
                };
            }
            
            if (filter.title_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'title_en',
                        filter.title_en,
                    ),
                };
            }
            
            if (filter.excerpt_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'excerpt_om',
                        filter.excerpt_om,
                    ),
                };
            }
            
            if (filter.excerpt_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'excerpt_am',
                        filter.excerpt_am,
                    ),
                };
            }
            
            if (filter.excerpt_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'excerpt_en',
                        filter.excerpt_en,
                    ),
                };
            }
            
            if (filter.content_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'content_om',
                        filter.content_om,
                    ),
                };
            }
            
            if (filter.content_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'content_am',
                        filter.content_am,
                    ),
                };
            }
            
            if (filter.content_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'news_posts',
                        'content_en',
                        filter.content_en,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.news_posts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'news_posts',
                        'title_en',
                        query,
                    ),
                ],
            };
        }

        const records = await db.news_posts.findAll({
            attributes: [ 'id', 'title_en' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title_en', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title_en,
        }));
    }

    
};

